## charls 1.0

=== CMakeLists.txt ===
project(charls)
cmake_minimum_required(VERSION 2.6)


# When user specify build type do not override settings:
IF(NOT CMAKE_BUILD_TYPE)
# The following compiler option are only meant for GCC:
IF(CMAKE_COMPILER_IS_GNUCC)
# the following is optimization micrmanagement that made better code for x86
# SET(CMAKE_CXX_FLAGS "-D NDEBUG -O3 -Wall -Wextra -pedantic -fvisibility=hidden -fomit-frame-pointer -momit-leaf-frame-pointer -fweb  -ftracer" )
SET(CMAKE_CXX_FLAGS "-D NDEBUG -O3" )
ENDIF(CMAKE_COMPILER_IS_GNUCC)
ENDIF(NOT CMAKE_BUILD_TYPE)

OPTION(charls_BUILD_SHARED_LIBS "Build CharLS with shared libraries." OFF)
SET(BUILD_SHARED_LIBS ${charls_BUILD_SHARED_LIBS})

add_library(CharLS header.cpp  interface.cpp  jpegls.cpp  )


add_executable(charlstest test/main.cpp test/time.cpp test/util.cpp test/bitstreamdamage.cpp test/compliance.cpp test/performance.cpp test/dicomsamples.cpp)
target_link_libraries (charlstest CharLS)

=== test/CMakeLists.txt ===
# test for charlls

#add_library(CharLS STATIC IMPORTED)

link_directories (..)

=== debian/changelog ===
charls (1.0-1) unstable; urgency=low

  * Initial release (Closes: #624346)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 27 Apr 2011 18:26:56 +0200

=== debian/control ===
Source: charls
Section: libs
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Mathieu Malaterre <mathieu.malaterre@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), cmake, quilt (>= 0.46-7~)
Standards-Version: 3.9.1
Homepage: http://charls.codeplex.com
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/charls/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/charls/trunk/

Package: libcharls-dev
Section: libdevel
Architecture: any
Depends: libcharls1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the JPEG-LS standard
 CharLS is an optimized implementation of the JPEG-LS standard for lossless and
 near-lossless image compression
 .
 JPEG-LS (ISO-14495-1/ITU-T.87) is a standard derived from the Hewlett Packard
 LOCO algorithm. JPEG LS has low complexity (meaning fast compression) and high
 compression ratios, similar to JPEG 2000. JPEG-LS is more similar to the old
 Lossless JPEG than to JPEG 2000, but interestingly the two different techniques
 result in vastly different performance characteristics. 

Package: libcharls1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the JPEG-LS standard
 CharLS is an optimized implementation of the JPEG-LS standard for lossless and
 near-lossless image compression
 .
 JPEG-LS (ISO-14495-1/ITU-T.87) is a standard derived from the Hewlett Packard
 LOCO algorithm. JPEG LS has low complexity (meaning fast compression) and high
 compression ratios, similar to JPEG 2000. JPEG-LS is more similar to the old
 Lossless JPEG than to JPEG 2000, but interestingly the two different techniques
 result in vastly different performance characteristics.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for charls

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh --parallel --with quilt --buildsystem=cmake $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING=Release -Dcharls_BUILD_SHARED_LIBS:BOOL=ON

VER_MAJOR = 1
VER_MINOR = 0
VER_FULL = $(VER_MAJOR).$(VER_MINOR)

UPSTREAM_SRC = CharLS-source-$(VER_FULL)
DEBIAN_SRC_DIR = charls-$(VER_FULL)
DEBIAN_SRC_TAR = charls_$(VER_FULL).orig.tar.gz

$(UPSTREAM_SRC).zip:
	wget -c -O CharLS-source-1.0.zip "http://download.codeplex.com/Project/Download/FileDownload.aspx?ProjectName=charls&DownloadId=165715&FileTime=129338164013100000&Build=17748"

get-orig-source: $(UPSTREAM_SRC).zip
	rm -rf $(DEBIAN_SRC_DIR)
	unzip -q $(UPSTREAM_SRC).zip -d $(DEBIAN_SRC_DIR)
	# UNIX eol
	dos2unix $(DEBIAN_SRC_DIR)/*.h
	dos2unix $(DEBIAN_SRC_DIR)/*.c*
	dos2unix $(DEBIAN_SRC_DIR)/*.txt
	# remove dataset to reduce source size
	rm -rf $(DEBIAN_SRC_DIR)/test/conformance/
	rm -rf $(DEBIAN_SRC_DIR)/test/jlsimage/
	rm $(DEBIAN_SRC_DIR)/test/*.raw
	rm $(DEBIAN_SRC_DIR)/test/*.jls
	rm $(DEBIAN_SRC_DIR)/test/*.dcm
	rm $(DEBIAN_SRC_DIR)/test/*.ppm
	rm $(DEBIAN_SRC_DIR)/test/MR2_UNC
	GZIP="--best --no-name" tar czf $(DEBIAN_SRC_TAR) $(DEBIAN_SRC_DIR)
	rm -rf $(DEBIAN_SRC_DIR)
	rm $(UPSTREAM_SRC).zip

=== debian/watch ===
version=3
http://charls.codeplex.com/releases/view/55406 CharLS-source-(.*)

## charls 1.1.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(charls)

# The following compiler option are only meant for GCC:
if (CMAKE_COMPILER_IS_GNUCC)
    # the following is optimization micromanagement that made better code for x86
    # SET(CMAKE_CXX_FLAGS "-D NDEBUG -O3 -Wall -Wextra -pedantic -fvisibility=hidden -fomit-frame-pointer -momit-leaf-frame-pointer -fweb  -ftracer" )

    # Define GNU C++ defines for both Debug and Release
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++03 -Wall -Wextra")

    # Define specific Debug settings.
    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")

    # Define specific Release settings.
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -D NDEBUG -O3")
ENDIF ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # Define clang C++ defines for both Debug and Release
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++03 -Wall -Wextra")

    # Define specific Debug settings.
    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")

    # Define specific Release settings.
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -D NDEBUG -O3")
endif()

option (BUILD_SHARED_LIBS "Build CharLS with shared libraries." OFF)
option (BUILD_TESTING     "Build tests"                         ON)

if (WIN32)
   if (BUILD_SHARED_LIBS)
     add_definitions(-D CHARLS_DLL)
   else()
     add_definitions(-D CHARLS_STATIC)
   endif()
endif()

set (charls_HEADERS
src/context.h         src/defaulttraits.h    src/jpegimagedatasegment.h  src/jpegsegment.h           src/lookuptable.h       src/publictypes.h
src/colortransform.h  src/contextrunmode.h   src/encoderstrategy.h       src/jpegmarker.h            src/losslesstraits.h    src/scan.h
src/config.h          src/decoderstrategy.h  src/header.h                src/jpegmarkersegment.h     src/jpegstreamwriter.h  src/processline.h     src/util.h)

add_library(CharLS src/interface.cpp src/jpegls.cpp src/jpegmarkersegment.cpp src/header.cpp src/jpegstreamwriter.cpp)
set (CHARLS_LIB_MAJOR_VERSION 1)
set (CHARLS_LIB_MINOR_VERSION 0)
set_target_properties( CharLS PROPERTIES
                              VERSION ${CHARLS_LIB_MAJOR_VERSION}.${CHARLS_LIB_MINOR_VERSION}
                              SOVERSION ${CHARLS_LIB_MAJOR_VERSION})

install (TARGETS CharLS RUNTIME DESTINATION bin
                        LIBRARY DESTINATION lib${LIB_SUFFIX}
                        ARCHIVE DESTINATION lib${LIB_SUFFIX})
install (FILES ${charls_HEADERS} DESTINATION include/CharLS)

if (BUILD_TESTING)
  add_executable(charlstest test/main.cpp test/time.cpp test/util.cpp test/bitstreamdamage.cpp test/compliance.cpp test/performance.cpp test/dicomsamples.cpp)
  target_link_libraries (charlstest CharLS)
endif ()

=== debian/changelog ===
charls (1.1.0+dfsg-2) unstable; urgency=medium

  [ Mathieu Malaterre ]
  * Adjust symbols

  [ Andreas Tille ]
  * Check whether we can use d-shlibs but no static lib is build.  Leave the
    code for documentation

 -- Andreas Tille <tille@debian.org>  Sun, 22 May 2016 16:11:53 +0200

charls (1.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version (use Files-Excluded)
    Closes: #824721, #824818
  * CharLS moved to Github
  * Packaging moved from SVN to Git
  * d/watch pointing to Github
    Closes: #824819
  * Better hardening

 -- Andreas Tille <tille@debian.org>  Fri, 20 May 2016 23:29:00 +0200

charls (1.0-7) unstable; urgency=medium

  * Fix EncoderStrategy (Thanks for the patch to Victor Derks
    <vbaderks@gmail.com>)
    Closes: #816607
  * Add myself to Uploaders
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Wed, 27 Apr 2016 15:52:42 +0200

charls (1.0-6) unstable; urgency=low

  * Really make the package multiarch capable. Closes: #768404
  * Bump Std-Vers to 3.9.6, no changes needed.

 -- Mathieu Malaterre <malat@debian.org>  Fri, 07 Nov 2014 09:20:43 +0100

charls (1.0-5) unstable; urgency=medium

  * Rework the symbol file to hide stl exported symbols

 -- Mathieu Malaterre <malat@debian.org>  Sun, 08 Dec 2013 12:26:36 +0100

charls (1.0-4) unstable; urgency=low

  * Do not set CMAKE_BUILD_TYPE. Closes: #731595
  * Fix exported symbols (add symbol file)

 -- Mathieu Malaterre <malat@debian.org>  Sun, 08 Dec 2013 08:56:17 +0100

charls (1.0-3) unstable; urgency=low

  * Team upload
  * debian/watch: uscan can not parse codeplex pages
  * debian/patches/charls_fix_clang_compilation_issue.patch:
    Apply patch from Mathieu Malaterre to enable compilation with clang
    Closes: #730612
  * cme fix dpkg-control
  * canonical Vcs-Svn URL
  * dicstinct short / long descriptions

 -- Andreas Tille <tille@debian.org>  Sat, 07 Dec 2013 08:53:27 +0100

charls (1.0-2) unstable; urgency=low

  [ Thorsten Alteholz ]
  * debian/rules: download URL for get-orig-source changed
  * debian/rules get-orig-source: put orig.tar.gz in ../tarballs to allow
    automatic build with svn-buildpackage

  [ Mathieu Malaterre ]
  * Use my @d.o alias
  * Remove DMUA flag
  * use dh(9), get hardening for free
  * make package multiarch
  * Bump Std-Vers to 3.9.3, no changes needed
  * Update d/copyright to latest dep5
  * Use dep3 for patches

 -- Mathieu Malaterre <malat@debian.org>  Wed, 11 Apr 2012 16:21:40 +0200

=== debian/control ===
Source: charls
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.18.0),
               cmake
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/charls.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/charls.git
Homepage: https://github.com/team-charls/charls

Package: libcharls-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcharls1 (= ${binary:Version}),
         ${misc:Depends}
Description: Implementation of the JPEG-LS standard (development libraries)
 CharLS is an optimized implementation of the JPEG-LS standard for lossless and
 near-lossless image compression
 .
 JPEG-LS (ISO-14495-1/ITU-T.87) is a standard derived from the Hewlett Packard
 LOCO algorithm. JPEG LS has low complexity (meaning fast compression) and high
 compression ratios, similar to JPEG 2000. JPEG-LS is more similar to the old
 Lossless JPEG than to JPEG 2000, but interestingly the two different techniques
 result in vastly different performance characteristics.
 .
 This package contains the development files.

Package: libcharls1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Implementation of the JPEG-LS standard
 CharLS is an optimized implementation of the JPEG-LS standard for lossless and
 near-lossless image compression
 .
 JPEG-LS (ISO-14495-1/ITU-T.87) is a standard derived from the Hewlett Packard
 LOCO algorithm. JPEG LS has low complexity (meaning fast compression) and high
 compression ratios, similar to JPEG 2000. JPEG-LS is more similar to the old
 Lossless JPEG than to JPEG 2000, but interestingly the two different techniques
 result in vastly different performance characteristics.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--version-script=../exports.version
export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden
export DEB_CXXFLAGS_MAINT_APPEND = -fvisibility=hidden -fvisibility-inlines-hidden
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_EXTRA_FLAGS += -DCMAKE_BUILD_TYPE:STRING=None \
 -DBUILD_SHARED_LIBS:BOOL=ON \
 -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

pkg_run = libcharls1
pkg_dev = libcharls-dev

override_dh_install-arch:
	# Runtime Package
	dh_install -p$(pkg_run) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so.*
	# Development Package
	dh_install -p$(pkg_dev) usr/include
	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so
#	dh_install -a
#	d-shlibmove --commit \
#		     --multiarch \
#		     --devunversioned \
#		     --movedev debian/tmp/usr/include/* usr/include \
#		     debian/tmp/usr/lib/*/*.so

=== debian/watch ===
version=3

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
   https://github.com/team-charls/charls/releases .*/archive/(1[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## charls 2.0.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(charls)

# The following compiler option are only meant for GCC:
if (CMAKE_COMPILER_IS_GNUCC)
    # the following is optimization micromanagement that made better code for x86
    # SET(CMAKE_CXX_FLAGS "-D NDEBUG -O3 -Wall -Wextra -pedantic -fvisibility=hidden -fomit-frame-pointer -momit-leaf-frame-pointer -fweb  -ftracer" )

    # Define GNU C++ defines for both Debug and Release
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -Wall -Wextra")

    # Define specific Debug settings.
    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")

    # Define specific Release settings.
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -D NDEBUG -O3")
ENDIF ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # Define clang C++ defines for both Debug and Release
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -Wall -Wextra")

    # Define specific Debug settings.
    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")

    # Define specific Release settings.
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -D NDEBUG -O3")
endif()

option (BUILD_SHARED_LIBS "Build CharLS with shared libraries." OFF)
option (BUILD_TESTING     "Build tests"                         ON)

if (WIN32)
   if (BUILD_SHARED_LIBS)
     add_definitions(-D CHARLS_DLL)
   else()
     add_definitions(-D CHARLS_STATIC)
   endif()
endif()

set (charls_PUBLIC_HEADERS src/charls.h src/publictypes.h)

add_library(CharLS src/interface.cpp src/jpegls.cpp src/jpegmarkersegment.cpp src/jpegstreamreader.cpp src/jpegstreamwriter.cpp)
set (CHARLS_LIB_MAJOR_VERSION 2)
set (CHARLS_LIB_MINOR_VERSION 0)
set_target_properties(CharLS PROPERTIES
                             VERSION ${CHARLS_LIB_MAJOR_VERSION}.${CHARLS_LIB_MINOR_VERSION}
                             SOVERSION ${CHARLS_LIB_MAJOR_VERSION})

install (TARGETS CharLS RUNTIME DESTINATION bin
                        LIBRARY DESTINATION lib${LIB_SUFFIX}
                        ARCHIVE DESTINATION lib${LIB_SUFFIX})
install (FILES ${charls_PUBLIC_HEADERS} DESTINATION include/CharLS)

if (BUILD_TESTING)
  add_executable(charlstest test/main.cpp test/time.cpp test/util.cpp test/bitstreamdamage.cpp test/compliance.cpp test/performance.cpp test/dicomsamples.cpp)
  target_link_libraries (charlstest CharLS)
endif ()

=== debian/changelog ===
charls (2.0.0+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * d/watch: Do not stick to charls 1.x any more
    Closes: #886560
  * New upstream version

  [ Mathieu Malaterre ]
  * Refresh patch for v2.0.0
  * Use default c++ standard used by gcc when compiling
  * Update to match SOVERSION

 -- Andreas Tille <tille@debian.org>  Thu, 03 Jan 2019 15:40:12 +0100

charls (1.1.0+dfsg-3) unstable; urgency=medium

  [ Mathieu Malaterre ]
  * Remove self from Uploaders

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * Do not Build-Depend dpkg-dev
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Remove trailing whitespace in debian/copyright
  * Remove unneeded quilt patches

 -- Andreas Tille <tille@debian.org>  Sun, 28 Oct 2018 06:49:29 +0100

=== debian/rules ===
--- 
+++ 
@@ -14,12 +14,12 @@
  -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"
 
 %:
-	dh $@ --parallel --buildsystem=cmake
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)
 
-pkg_run = libcharls1
+pkg_run = libcharls2
 pkg_dev = libcharls-dev
 
 override_dh_install-arch:

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
   https://github.com/team-charls/charls/releases .*/archive/([\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## charls 2.1.0+dfsg

=== debian/changelog ===
charls (2.1.0+dfsg-8) unstable; urgency=medium

  [ Mathieu Malaterre ]
  * Team upload.
  * d/control: Run wrap-and-sort

  [ Adrian Bunk ]
  * d/control: Provide a clean upgrade path. Closes: #974544

 -- Mathieu Malaterre <malat@debian.org>  Thu, 12 Nov 2020 09:34:06 +0100

charls (2.1.0+dfsg-7) unstable; urgency=medium

  * Team upload.
  * d/mainscript: CharLS directory was removed in -6 version
  * d/control: Make sure to document issue with dcmtk/charls. See #973723
  * d/rule: Really install symlink. Closes: #972867

 -- Mathieu Malaterre <malat@debian.org>  Mon, 09 Nov 2020 14:41:25 +0100

charls (2.1.0+dfsg-6) unstable; urgency=medium

  [ Mathieu Malaterre ]
  * Team upload.
  * d/patches: Remove change_library_name patch
  * d/rules: Provide symlinks to mimic CharLS 2.0.x behavior. Closes: #972867

  [ Sebastiaan Couwenberg ]
  * d/*.maintscript: Switching a directory to symlink

 -- Mathieu Malaterre <malat@debian.org>  Tue, 03 Nov 2020 10:55:49 +0100

charls (2.1.0+dfsg-5) unstable; urgency=medium

  * Team upload.
  * d/patches: Refresh patches with minor cleanups
  * d/patches: Remove old patch for visibility stuff on GCC
  * d/rules: Do not compile the SAMPLES/TESTS
  * d/patches: Really only expose the public symbols
  * d/rules: Remove reference to old LIB_SUFFIX cmake variable

 -- Mathieu Malaterre <malat@debian.org>  Thu, 29 Oct 2020 17:58:11 +0100

charls (2.1.0+dfsg-4) unstable; urgency=medium

  * Team upload.
  * d/symbols: Fix incorrect entries in symbol file.

 -- Mathieu Malaterre <malat@debian.org>  Sun, 25 Oct 2020 18:00:55 +0100

charls (2.1.0+dfsg-3) unstable; urgency=medium

  * Modify symbols to hopefully build on failing archs

 -- Shayan Doust <hello@shayandoust.me>  Thu, 01 Oct 2020 14:27:14 +0100

charls (2.1.0+dfsg-2) unstable; urgency=medium

  * libCharLS.so not libcharls.so to prevent breakage
    (Closes: #971425, #971431, #971435)
  * Symbols file should mention libCharLS.so.2 with correct capitalisation

 -- Shayan Doust <hello@shayandoust.me>  Wed, 30 Sep 2020 19:07:18 +0100

charls (2.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.1.0+dfsg (Closes: #960578)
  * Update patches including exports.version
  * Update symbols
  * Add myself as an uploader
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Shayan Doust <hello@shayandoust.me>  Tue, 29 Sep 2020 20:53:35 +0000

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,24 @@
 Source: charls
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Mathieu Malaterre <malat@debian.org>,
-           Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
-               dpkg-dev (>= 1.18.0),
-               cmake
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/charls.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/charls.git
+Build-Depends: cmake, debhelper-compat (= 13)
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/med-team/charls
+Vcs-Git: https://salsa.debian.org/med-team/charls.git
 Homepage: https://github.com/team-charls/charls
+Rules-Requires-Root: no
 
 Package: libcharls-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libcharls1 (= ${binary:Version}),
-         ${misc:Depends}
+Depends: libcharls2 (= ${binary:Version}), ${misc:Depends}
+Pre-Depends: dpkg (>= 1.17.14)
+Breaks: libdcmtk-dev (<< 3.6.5-1~)
+Replaces: libdcmtk-dev (<< 3.6.5-1~)
 Description: Implementation of the JPEG-LS standard (development libraries)
  CharLS is an optimized implementation of the JPEG-LS standard for lossless and
  near-lossless image compression
@@ -30,12 +31,11 @@
  .
  This package contains the development files.
 
-Package: libcharls1
+Package: libcharls2
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Implementation of the JPEG-LS standard
  CharLS is an optimized implementation of the JPEG-LS standard for lossless and

=== debian/rules ===
--- 
+++ 
@@ -9,9 +9,12 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
+# SAMPLES/TESTS should be OFF by default:
+# https://github.com/team-charls/charls/issues/81#issuecomment-716385532
 CMAKE_EXTRA_FLAGS += -DCMAKE_BUILD_TYPE:STRING=None \
  -DBUILD_SHARED_LIBS:BOOL=ON \
- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"
+ -DCHARLS_BUILD_SAMPLES:BOOL=OFF \
+ -DCHARLS_BUILD_TESTS:BOOL=OFF \
 
 %:
 	dh $@ --buildsystem=cmake
@@ -28,6 +31,10 @@
 	# Development Package
 	dh_install -p$(pkg_dev) usr/include
 	dh_install -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so
+	# See #971425, #971431 & #971435:
+	dh_link -p$(pkg_run) usr/lib/$(DEB_HOST_MULTIARCH)/libcharls.so.2 usr/lib/$(DEB_HOST_MULTIARCH)/libCharLS.so.2
+	dh_link -p$(pkg_dev) usr/lib/$(DEB_HOST_MULTIARCH)/libcharls.so usr/lib/$(DEB_HOST_MULTIARCH)/libCharLS.so
+	dh_link -p$(pkg_dev) usr/include/charls usr/include/CharLS
 #	dh_install -a
 #	d-shlibmove --commit \
 #		     --multiarch \

## charls 2.2.0%2Bdfsg

=== debian/changelog ===
charls (2.2.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * d/rules: Make sure to install cmake specific files

 -- Mathieu Malaterre <malat@debian.org>  Wed, 27 Jan 2021 16:59:40 +0100

charls (2.2.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.2.0+dfsg
  * d/patches: Refresh patches for 2.2.0 release
  * d/control: Bump Std-Vers to 4.5.1, no changes needed
  * d/copyright: Remove binary file
  * d/symbols: Update the symbol file with the newly added one
  * d/control: Make sure to require cmake >= 3.13

 -- Mathieu Malaterre <malat@debian.org>  Wed, 27 Jan 2021 16:07:22 +0100

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
            Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: cmake, debhelper-compat (= 13)
-Standards-Version: 4.5.0
+Build-Depends: cmake (>= 3.13), debhelper-compat (= 13)
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/charls
 Vcs-Git: https://salsa.debian.org/med-team/charls.git
 Homepage: https://github.com/team-charls/charls

## charls 2.2.0+dfsg

=== CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.13...3.19)

# Extract the version info from version.h
file(READ "include/charls/version.h" version)
string(REGEX MATCH "CHARLS_VERSION_MAJOR ([0-9]*)" _ ${version})
set(version_major ${CMAKE_MATCH_1})
string(REGEX MATCH "CHARLS_VERSION_MINOR ([0-9]*)" _ ${version})
set(version_minor ${CMAKE_MATCH_1})
string(REGEX MATCH "CHARLS_VERSION_PATCH ([0-9]*)" _ ${version})
set(version_patch ${CMAKE_MATCH_1})
message(STATUS "CharLS version: ${version_major}.${version_minor}.${version_patch}")

project(charls VERSION ${version_major}.${version_minor}.${version_patch} LANGUAGES C CXX)

# Determine if project is built as a subproject (using add_subdirectory) or if it is the master project.
set(MASTER_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(MASTER_PROJECT ON)
  message(STATUS "Building as master project, CMake version: ${CMAKE_VERSION}")
endif ()

# The basic options to control what is build extra.
option(CHARLS_BUILD_TESTS "Build test application" ${MASTER_PROJECT})
option(CHARLS_BUILD_FUZZ_TEST "Build AFL fuzzer application" ${MASTER_PROJECT})
option(CHARLS_BUILD_SAMPLES "Build sample applications" ${MASTER_PROJECT})
option(CHARLS_INSTALL "Generate the install target." ${MASTER_PROJECT})

# Provide BUILD_SHARED_LIBS as an option for GUI tools
option(BUILD_SHARED_LIBS "Will control if charls lib is build as shared lib/DLL or static library")

# The options used by the CI builds to ensure the source remains warning free.
# Not enabled by default to make CharLS package and end-user friendly.
option(CHARLS_PEDANTIC_WARNINGS "Enable extra warnings and static analysis." OFF)
option(CHARLS_THREAT_WARNINGS_AS_ERRORS "Treat Warnings as Errors." OFF)

# CharLS requires C++14 or newer.
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Configure the supported C++ compilers: gcc, clang and MSVC
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  set(PEDANTIC_CXX_COMPILE_FLAGS
    -pedantic-errors
    -Wall
    -Wextra
    -pedantic
    -Wold-style-cast
    -Wfloat-equal
    -Wlogical-op
    -Wundef
    -Wredundant-decls
    -Wshadow
    -Wwrite-strings
    -Wpointer-arith
    -Wcast-qual
    -Wformat=2
    -Wmissing-include-dirs
    -Wcast-align
    -Wctor-dtor-privacy
    -Wdisabled-optimization
    -Winvalid-pch
    -Woverloaded-virtual
    -Wnon-virtual-dtor
    -Wnoexcept
    -Wdouble-promotion
    -Wtrampolines
    -Wzero-as-null-pointer-constant
    -Wuseless-cast
    -Wvector-operation-performance
    -Wsized-deallocation
  )
  if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
      set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
        -Wshift-overflow=2
        -Wnull-dereference
        -Wduplicated-cond
      )
  endif()

  set(WERROR_FLAG -Werror)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(PEDANTIC_CXX_COMPILE_FLAGS
      -Weverything
      -Wpedantic
      -Wno-weak-vtables                       # Ignore, linker will remove the couple of extra vtables.
      -Wno-padded                             # Ignore, padding optimization is not needed.
      -Wno-c++98-compat                       # Ignore, CharLS 2.x targets C++14, ignore C++98 compatibility.
      -Wno-c++98-compat-pedantic              # Ignore, CharLS 2.x targets C++14, ignore C++98 compatibility.
      -Wno-global-constructors                # Ignore, by design CharLS uses types created at startup.
      -Wno-switch-enum                        # Ignore, cases are handled by default.
      -Wno-sign-conversion                    # Ignore, would just introduce ugly static_asserts.
      -Wno-exit-time-destructors              # Ignore, by design exit-time destructors are used.
      -Wno-missing-braces                     # Ignore, False warning in clang 5.0, fixed in 6.0.
  )

  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0.2)
    set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
      -Wno-undefined-func-template            # Ignore, linker will complain if final template code is not available.
    )
  endif()

  set(WERROR_FLAG -Werror)
endif()

if(MSVC)
  set(PEDANTIC_CXX_COMPILE_FLAGS /W4)
  set(WERROR_FLAG /WX)

  # Exception settings are not set for ARM(64) when building for Ninja
  string(TOLOWER ${CMAKE_CXX_COMPILER} CXX_COMPILER_LOWER)
  string(FIND ${CXX_COMPILER_LOWER} "arm" ARM_DETECTED)
  if(${ARM_DETECTED} GREATER 0)
    add_compile_options("/EHsc")
  endif()

  # Remove option /GR (/GR is added by default by CMake). /GR is already the default
  # and this makes it possible to use /GR- without warnings.
  string(REGEX REPLACE " /GR" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  # All C and C++ source files are in utf-8 without signature (bom), MSVC requires utf-8 switch to read files correctly.
  add_compile_options("/utf-8")

  # Zc:__cplusplus: Will configure the MSVC compiler to use the correct value for the __cplusplus macro
  # (introduced with Visual Studio 2017 version 15.7)
  if(MSVC_VERSION GREATER_EQUAL 1914)
    add_compile_options("/Zc:__cplusplus")
  endif()

  # /Zc:throwingNew: Will configure the MSVC compiler that only the standard throwing operator new is used.
  add_compile_options("/Zc:throwingNew")

  # /guard:cf: Will enable Control Flow Guard, which provides addition compile time and runtime checks.
  add_compile_options("/guard:cf")
  add_link_options("/guard:cf")
endif()

# When enabled apply the pedantic warnings options and warnings as errors to globally.
if(CHARLS_PEDANTIC_WARNINGS)

  if(MSVC)
    # Remove existing warning level (W3 is added by default by CMake), duplicate level will generate cmd-line warnings.
    string(REGEX REPLACE " /W[0-4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  endif()

  add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:${PEDANTIC_CXX_COMPILE_FLAGS}>")
endif()

if(CHARLS_THREAT_WARNINGS_AS_ERRORS)
  add_compile_options(${WERROR_FLAG})
endif()

include(src/CMakeLists.txt)

if(CHARLS_BUILD_TESTS)
  add_subdirectory(test)
endif()

if(CHARLS_BUILD_FUZZ_TEST)
  add_subdirectory(fuzztest)
endif()

if(CHARLS_BUILD_SAMPLES)
  add_subdirectory(samples)
endif()

=== fuzztest/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_executable(fuzztest "")

target_sources(fuzztest PRIVATE main.cpp)

set_target_properties(fuzztest PROPERTIES CXX_VISIBILITY_PRESET hidden)

target_link_libraries(fuzztest PRIVATE charls)

if(MSVC)
  # POSIX functions are used, required for AFL.
  target_compile_definitions(fuzztest PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

=== samples/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(convert.c)
add_subdirectory(convert.cpp)

=== src/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

# Define the library "charls" target
add_library(charls "")

target_include_directories(charls PUBLIC
  $<BUILD_INTERFACE:${charls_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

if(NOT BUILD_SHARED_LIBS)
  target_compile_definitions(charls PUBLIC CHARLS_STATIC)
endif()

if(WIN32 AND BUILD_SHARED_LIBS)
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x64")
  else()
    set_target_properties(charls PROPERTIES OUTPUT_NAME "charls-2-x86")
  endif()
endif()

# Disable C++ run-time type info (dynamic cast + typeid). CharLS doesn't use
# this functionality and disabling it will result in a smaller image.
# Don't do this for gcc and clang (normally done with -fno-rtti) as it will cause
# UBSAN warnings as jpegls_category is derived from std::error_category
# If the base class was built with RTTI and has virtual functions, the derived class
# also needs to be build with RTTI.
if(MSVC)
  target_compile_options(charls PRIVATE /GR-)
endif()

set_target_properties(charls PROPERTIES
                      VERSION ${PROJECT_VERSION}
                      SOVERSION ${PROJECT_VERSION_MAJOR})

target_compile_definitions(charls PRIVATE CHARLS_LIBRARY_BUILD)

set(HEADERS
    "include/charls/api_abi.h"
    "include/charls/annotations.h"
    "include/charls/charls.h"
    "include/charls/charls_jpegls_decoder.h"
    "include/charls/charls_jpegls_encoder.h"
    "include/charls/jpegls_error.h"
    "include/charls/public_types.h"
    "include/charls/version.h"
)
foreach(header HEADERS)
  list(APPEND CHARLS_PUBLIC_HEADER $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${header}>)
  list(APPEND CHARLS_PUBLIC_HEADER $<INSTALL_INTERFACE:${header}>)
endforeach()

set_target_properties(charls PROPERTIES CXX_VISIBILITY_PRESET hidden)
set_property(TARGET charls PROPERTY PUBLIC_HEADER ${HEADERS})

target_sources(charls
  PUBLIC
    ${CHARLS_PUBLIC_HEADERS}
  PRIVATE
    "${CMAKE_CURRENT_LIST_DIR}/byte_span.h"
    "${CMAKE_CURRENT_LIST_DIR}/charls_jpegls_decoder.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/charls_jpegls_encoder.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/coding_parameters.h"
    "${CMAKE_CURRENT_LIST_DIR}/color_transform.h"
    "${CMAKE_CURRENT_LIST_DIR}/constants.h"
    "${CMAKE_CURRENT_LIST_DIR}/context.h"
    "${CMAKE_CURRENT_LIST_DIR}/context_run_mode.h"
    "${CMAKE_CURRENT_LIST_DIR}/decoder_strategy.h"
    "${CMAKE_CURRENT_LIST_DIR}/default_traits.h"
    "${CMAKE_CURRENT_LIST_DIR}/encoder_strategy.h"
    "${CMAKE_CURRENT_LIST_DIR}/jls_codec_factory.h"
    "${CMAKE_CURRENT_LIST_DIR}/jpegls_error.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/jpegls.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/jpeg_marker_code.h"
    "${CMAKE_CURRENT_LIST_DIR}/jpegls_preset_coding_parameters.h"
    "${CMAKE_CURRENT_LIST_DIR}/jpegls_preset_parameters_type.h"
    "${CMAKE_CURRENT_LIST_DIR}/jpeg_stream_reader.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/jpeg_stream_writer.cpp"
    "${CMAKE_CURRENT_LIST_DIR}/lookup_table.h"
    "${CMAKE_CURRENT_LIST_DIR}/lossless_traits.h"
    "${CMAKE_CURRENT_LIST_DIR}/process_line.h"
    "${CMAKE_CURRENT_LIST_DIR}/scan.h"
    "${CMAKE_CURRENT_LIST_DIR}/util.h"
    "${CMAKE_CURRENT_LIST_DIR}/version.cpp"
)

if(WIN32 AND BUILD_SHARED_LIBS)
  # Only add the Win32 resource script file when building a DLL
  target_sources(charls PRIVATE "${CMAKE_CURRENT_LIST_DIR}/charls.rc")

  # Only add the definition file when building a x86 DLL with MSVC
  # The definition file is needed to ensure the legacy functions are exported with the correct name
  if(MSVC AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_sources(charls PRIVATE "${CMAKE_CURRENT_LIST_DIR}/charls.def")
  endif()
endif()

if(CHARLS_INSTALL)
  include(GNUInstallDirs)

  install(TARGETS charls EXPORT charls_targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/charls
  )

  # Configure and copy the pkg-config configuration file.
  # These type of configuration file can make it easier to detect if charls is installed.
  CONFIGURE_FILE("${CMAKE_CURRENT_LIST_DIR}/charls-template.pc" "charls.pc" @ONLY)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/charls.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

  install (EXPORT charls_targets FILE charlsConfig.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/charls)
endif()

=== samples/convert.c/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_executable(convert-c "")

target_sources(convert-c
  PRIVATE
    main.c
)

if(WIN32 AND MSVC_VERSION GREATER_EQUAL 1920)
  # Only add the manifest file when building a Windows app
  target_sources(convert-c PRIVATE app.manifest)
endif()

target_link_libraries(convert-c PRIVATE charls)

if(MSVC)
  # Not all compilers come with the secure C standard extension functions, making it difficult to use them.
  # Disable the MSVC warning about not using these functions to keep the sample code simple and easy to understand.
  target_compile_definitions(convert-c PRIVATE _CRT_SECURE_NO_WARNINGS)
endif()

=== debian/changelog ===
charls (2.2.0+dfsg-3) unstable; urgency=medium

  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 24 Sep 2021 11:59:04 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,9 @@
            Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: cmake (>= 3.13), debhelper-compat (= 13)
-Standards-Version: 4.5.1
+Build-Depends: cmake (>= 3.13),
+               debhelper-compat (= 13)
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/charls
 Vcs-Git: https://salsa.debian.org/med-team/charls.git
 Homepage: https://github.com/team-charls/charls
@@ -15,8 +16,8 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libcharls2 (= ${binary:Version}), ${misc:Depends}
-Pre-Depends: dpkg (>= 1.17.14)
+Depends: libcharls2 (= ${binary:Version}),
+         ${misc:Depends}
 Breaks: libdcmtk-dev (<< 3.6.5-1~)
 Replaces: libdcmtk-dev (<< 3.6.5-1~)
 Description: Implementation of the JPEG-LS standard (development libraries)
@@ -35,7 +36,8 @@
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Implementation of the JPEG-LS standard
  CharLS is an optimized implementation of the JPEG-LS standard for lossless and

## charls 2.2.1+dfsg

=== samples/convert.cpp/CMakeLists.txt ===
# Copyright (c) Team CharLS.
# SPDX-License-Identifier: BSD-3-Clause

add_executable(convert-cpp "")

target_sources(convert-cpp
  PRIVATE
    pch.h
    bmp_image.h
    main.cpp
)

if(WIN32 AND MSVC_VERSION GREATER_EQUAL 1920)
  # Only add the manifest file when building a Windows app
  target_sources(convert-cpp PRIVATE app.manifest)
endif()

set_target_properties(convert-cpp PROPERTIES CXX_VISIBILITY_PRESET hidden)

target_link_libraries(convert-cpp PRIVATE charls)

=== debian/changelog ===
charls (2.2.1+dfsg-1~bpo11+1) bullseye-backports; urgency=medium

  * Team upload.
  * Rebuild for bullseye-backports.
  * d/watch: Update watch to latest version
  * New upstream version 2.2.1+dfsg. Closes: #1004842

 -- Mathieu Malaterre <malat@debian.org>  Mon, 07 Feb 2022 10:01:45 +0100

## charls 2.3.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Copyright (c) Team CharLS.
 # SPDX-License-Identifier: BSD-3-Clause
 
-cmake_minimum_required(VERSION 3.13...3.19)
+cmake_minimum_required(VERSION 3.13...3.22)
 
 # Extract the version info from version.h
 file(READ "include/charls/version.h" version)
@@ -31,10 +31,10 @@
 # Provide BUILD_SHARED_LIBS as an option for GUI tools
 option(BUILD_SHARED_LIBS "Will control if charls lib is build as shared lib/DLL or static library")
 
-# The options used by the CI builds to ensure the source remains warning free.
-# Not enabled by default to make CharLS package and end-user friendly.
+# These options are used by the CI pipeline to ensure new warnings are detected quickly.
+# Not enabled by default to ensure the CharLS package is end-user friendly.
 option(CHARLS_PEDANTIC_WARNINGS "Enable extra warnings and static analysis." OFF)
-option(CHARLS_THREAT_WARNINGS_AS_ERRORS "Treat Warnings as Errors." OFF)
+option(CHARLS_TREAT_WARNING_AS_ERROR "Treat a warning as an error." OFF)
 
 # CharLS requires C++14 or newer.
 set(CMAKE_CXX_STANDARD 14)
@@ -44,10 +44,10 @@
 # Configure the supported C++ compilers: gcc, clang and MSVC
 if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
   set(PEDANTIC_CXX_COMPILE_FLAGS
-    -pedantic-errors
     -Wall
     -Wextra
     -pedantic
+    -pedantic-errors
     -Wold-style-cast
     -Wfloat-equal
     -Wlogical-op
@@ -72,6 +72,7 @@
     -Wuseless-cast
     -Wvector-operation-performance
     -Wsized-deallocation
+    -Wattributes
   )
   if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
       set(PEDANTIC_CXX_COMPILE_FLAGS ${PEDANTIC_CXX_COMPILE_FLAGS}
@@ -81,13 +82,36 @@
       )
   endif()
 
-  set(WERROR_FLAG -Werror)
+  set(WARNINGS_AS_ERRORS_FLAG_COMPILER -Werror)
+  set(WARNINGS_AS_ERRORS_FLAG_LINKER LINKER:--fatal-warnings)
 endif()
 
 if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   set(PEDANTIC_CXX_COMPILE_FLAGS
-      -Weverything
+      -Wall
+      -Wextra # (-W is synonym)
+      -Wnon-gcc
       -Wpedantic
+      -Walloca
+      -Wcast-qual
+      -Wformat=2
+      -Wvla
+      -Warray-bounds-pointer-arithmetic
+      -Wassign-enum
+      -Wbad-function-cast
+      -Wconditional-uninitialized
+      -Widiomatic-parentheses
+      -Wimplicit-fallthrough
+      -Wloop-analysis
+      -Wpointer-arith
+      -Wshift-sign-overflow
+      -Wtautological-constant-in-range-compare
+      -Wunreachable-code-aggressive
+      -Wthread-safety
+      -Wthread-safety-beta
+      -Wcomma
+      # -Weverything provides the option to discover usefull Clang warnings.
+      # The list below ignores not useful Weverything warnings.
       -Wno-weak-vtables                       # Ignore, linker will remove the couple of extra vtables.
       -Wno-padded                             # Ignore, padding optimization is not needed.
       -Wno-c++98-compat                       # Ignore, CharLS 2.x targets C++14, ignore C++98 compatibility.
@@ -105,12 +129,16 @@
     )
   endif()
 
-  set(WERROR_FLAG -Werror)
+  set(WARNINGS_AS_ERRORS_FLAG_COMPILER -Werror)
+  if (NOT CMAKE_CXX_COMPILER_ID MATCHES "AppleClang")
+    set(WARNINGS_AS_ERRORS_FLAG_LINKER LINKER:--fatal-warnings)
+  endif()
 endif()
 
 if(MSVC)
   set(PEDANTIC_CXX_COMPILE_FLAGS /W4)
-  set(WERROR_FLAG /WX)
+  set(WARNINGS_AS_ERRORS_FLAG_COMPILER /WX)
+  set(WARNINGS_AS_ERRORS_FLAG_LINKER /WX)
 
   # Exception settings are not set for ARM(64) when building for Ninja
   string(TOLOWER ${CMAKE_CXX_COMPILER} CXX_COMPILER_LOWER)
@@ -127,22 +155,37 @@
   add_compile_options("/utf-8")
 
   # Zc:__cplusplus: Will configure the MSVC compiler to use the correct value for the __cplusplus macro
-  # (introduced with Visual Studio 2017 version 15.7)
+  # This option is introduced with Visual Studio 2017 version 15.7
   if(MSVC_VERSION GREATER_EQUAL 1914)
     add_compile_options("/Zc:__cplusplus")
   endif()
 
   # /Zc:throwingNew: Will configure the MSVC compiler that only the standard throwing operator new is used.
   add_compile_options("/Zc:throwingNew")
+
+  # /permissive-: Will configure the MSVC compiler to accept only standards conformance C++
+  # This option is introduced with Visual Studio 2017.
+  if(MSVC_VERSION GREATER_EQUAL 1910)
+    add_compile_options("/permissive-")
+  endif()
+
+  # /ZH:SHA_256: Wiill use SHA 256 for checksums between source code and debug symbols (more secure)
+  add_compile_options("/ZH:SHA_256")
 
   # /guard:cf: Will enable Control Flow Guard, which provides addition compile time and runtime checks.
   add_compile_options("/guard:cf")
   add_link_options("/guard:cf")
+
+  # /CETCOMPAT: Mark executable image compatible with the Control-flow Enforcement Technology (CET) Shadow Stack.
+  # CET is only supported by x64 and x86 CPUs (11th generation Intel and AMD Zen3 and newer)
+  if(${ARM_DETECTED} EQUAL 0)
+    add_link_options("/CETCOMPAT")
+  endif()
+
 endif()
 
 # When enabled apply the pedantic warnings options and warnings as errors to globally.
 if(CHARLS_PEDANTIC_WARNINGS)
-
   if(MSVC)
     # Remove existing warning level (W3 is added by default by CMake), duplicate level will generate cmd-line warnings.
     string(REGEX REPLACE " /W[0-4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
@@ -151,8 +194,9 @@
   add_compile_options("$<$<COMPILE_LANGUAGE:CXX>:${PEDANTIC_CXX_COMPILE_FLAGS}>")
 endif()
 
-if(CHARLS_THREAT_WARNINGS_AS_ERRORS)
-  add_compile_options(${WERROR_FLAG})
+if(CHARLS_TREAT_WARNING_AS_ERROR)
+  add_compile_options(${WARNINGS_AS_ERRORS_FLAG_COMPILER})
+  add_link_options(${WARNINGS_AS_ERRORS_FLAG_LINKER})
 endif()
 
 include(src/CMakeLists.txt)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,19 @@
 
 # Define the library "charls" target
 add_library(charls "")
+
+# Enable IPO (Interprocedural optimization) for shared lib in release mode with GCC for better performance.
+# Note: MSVC and Clang will create with IPO larger binaries that are not significant faster.
+if(BUILD_SHARED_LIBS AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
+  include(CheckIPOSupported)
+  check_ipo_supported(RESULT ipo_supported)
+  if(ipo_supported)
+      message("-- IPO is supported and used")
+      set_property(TARGET charls PROPERTY INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
+  else()
+      message("-- IPO is not supported")
+  endif()
+endif()
 
 target_include_directories(charls PUBLIC
   $<BUILD_INTERFACE:${charls_SOURCE_DIR}/include>
@@ -64,7 +77,7 @@
     "${CMAKE_CURRENT_LIST_DIR}/coding_parameters.h"
     "${CMAKE_CURRENT_LIST_DIR}/color_transform.h"
     "${CMAKE_CURRENT_LIST_DIR}/constants.h"
-    "${CMAKE_CURRENT_LIST_DIR}/context.h"
+    "${CMAKE_CURRENT_LIST_DIR}/context_regular_mode.h"
     "${CMAKE_CURRENT_LIST_DIR}/context_run_mode.h"
     "${CMAKE_CURRENT_LIST_DIR}/decoder_strategy.h"
     "${CMAKE_CURRENT_LIST_DIR}/default_traits.h"
@@ -98,6 +111,7 @@
 
 if(CHARLS_INSTALL)
   include(GNUInstallDirs)
+  include(CMakePackageConfigHelpers)
 
   install(TARGETS charls EXPORT charls_targets
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
@@ -106,10 +120,14 @@
     PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/charls
   )
 
+  write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/charlsConfigVersion.cmake COMPATIBILITY SameMajorVersion)
+
   # Configure and copy the pkg-config configuration file.
   # These type of configuration file can make it easier to detect if charls is installed.
   CONFIGURE_FILE("${CMAKE_CURRENT_LIST_DIR}/charls-template.pc" "charls.pc" @ONLY)
   install(FILES "${CMAKE_CURRENT_BINARY_DIR}/charls.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
 
-  install (EXPORT charls_targets FILE charlsConfig.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/charls)
+  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/charlsConfigVersion.cmake" DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/charls")
+
+  install(EXPORT charls_targets FILE charlsConfig.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/charls)
 endif()

=== debian/changelog ===
charls (2.3.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * d/patches: Refactor patch for upstream submission
  * d/patches: Simplify std c++ version setup
  * New upstream version 2.3.1+dfsg
  * d/rules: Start building with more agressive warnings
  * d/rules: Start building test again
  * d/rules: Start building applications
  * d/rules: Simplify configuration using dpkg/default.mk
  * d/patches: Hide more symbols since DPKG_GENSYMBOLS_CHECK_LEVEL=4 now
  * d/patches: Add missing visibility setup

 -- Mathieu Malaterre <malat@debian.org>  Wed, 26 Jan 2022 10:20:00 +0100

charls (2.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.3.0+dfsg
  * d/patches: Refresh patches
  * d/symbols: Update symbol file to match new release

 -- Mathieu Malaterre <malat@debian.org>  Wed, 26 Jan 2022 09:20:37 +0100

charls (2.2.0+dfsg-4) unstable; urgency=medium

  * Extend CMakeLists.txt to create and install charlsConfigVersion.cmake
    Closes: #995831

 -- Andreas Tille <tille@debian.org>  Tue, 21 Dec 2021 07:59:22 +0100
